import { jsx as i, jsxs as D, Fragment as M } from "react/jsx-runtime";
import y from "clsx";
import * as c from "react";
import { useRef as b, useReducer as N, useEffect as _, useId as w } from "react";
import { useFloating as x, useClick as $, useDismiss as S, useRole as O, useInteractions as F, useMergeRefs as k, FloatingPortal as L, FloatingOverlay as P, FloatingFocusManager as U } from "@floating-ui/react";
const I = "SET_ANNOUNCEMENT", R = "CLEAR_ANNOUNCEMENT", V = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, j = (e, n) => {
  switch (n == null ? void 0 : n.type) {
    case I:
      return {
        ...e,
        announcement: n.payload
      };
    case R:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, B = ({
  onAnnouncementClear: e,
  dispatch: n
}) => {
  n({
    type: R
  }), typeof e == "function" && e();
}, C = ({
  children: e,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: o,
  onAnnouncementClear: t,
  dispatch: l
}) => {
  (o == null ? void 0 : o.current) !== null && clearTimeout(o.current), e !== null && l({
    type: I,
    payload: e
  }), n && (o.current = setTimeout(
    () => B({
      onAnnouncementClear: t,
      dispatch: l
    }),
    n
  ));
}, q = ({
  children: e,
  announcementTimeoutRef: n,
  announcementDelay: o,
  clearAnnouncementDelay: t,
  clearAnnouncementTimeoutRef: l,
  onAnnouncementClear: r,
  dispatch: a
}) => {
  clearTimeout(n.current), o ? n.current = setTimeout(C, o, {
    children: e,
    clearAnnouncementDelay: t,
    clearAnnouncementTimeoutRef: l,
    onAnnouncementClear: r,
    dispatch: a
  }) : C({
    children: e,
    clearAnnouncementDelay: t,
    clearAnnouncementTimeoutRef: l,
    onAnnouncementClear: r,
    dispatch: a
  });
};
function W({
  children: e,
  className: n,
  politeness: o,
  role: t = null,
  announcementDelay: l,
  clearAnnouncementDelay: r,
  onAnnouncementClear: a,
  visible: s,
  ...p
}) {
  const u = b(), d = b(), [m, f] = N(j, {
    announcement: null
  });
  let h = o;
  typeof h > "u" && (h = t ? V[t] : "assertive"), _(() => {
    q({
      announcementTimeoutRef: u,
      announcementDelay: l,
      children: e,
      clearAnnouncementDelay: r,
      clearAnnouncementTimeoutRef: d,
      onAnnouncementClear: a,
      dispatch: f
    });
  }, [
    e,
    l,
    r,
    a
  ]);
  const g = y(n, {
    "sr-only": !s
  });
  return /* @__PURE__ */ i(
    "div",
    {
      "aria-live": h,
      ...t && { role: t },
      className: g,
      ...p,
      children: m.announcement
    }
  );
}
const E = c.createContext(null);
function H({
  initialOpen: e = !1,
  open: n,
  onOpenChange: o
} = {}) {
  const [t, l] = c.useState(e), [r, a] = c.useState(), [s, p] = c.useState(), u = n ?? t, d = o ?? l, m = x({
    open: u,
    onOpenChange: d
  }), f = m.context, h = $(f, {
    enabled: n == null
  }), g = S(f, {
    outsidePress: !1,
    outsidePressEvent: "mousedown"
  }), T = O(f), A = F([h, g, T]);
  return c.useMemo(
    () => ({
      open: u,
      setOpen: d,
      ...A,
      ...m,
      labelId: r,
      descriptionId: s,
      setLabelId: a,
      setDescriptionId: p
    }),
    [u, d, A, m, r, s]
  );
}
const v = () => {
  const e = c.useContext(E);
  if (e == null)
    throw new Error("Modal components must be wrapped in <Modal />");
  return e;
};
function X({
  children: e,
  ...n
}) {
  const o = H(n);
  return /* @__PURE__ */ i(E.Provider, { value: o, children: e });
}
const Y = c.forwardRef(function(e, n) {
  const { context: o, ...t } = v(), l = k([t.refs.setFloating, n]);
  if (!o.open)
    return null;
  const { overlayBackground: r, ...a } = e, s = y("grid place-items-center", {
    [`${r}`]: r,
    "bg-black sm:bg-black/[.8]": !r
  });
  return /* @__PURE__ */ i(L, { children: /* @__PURE__ */ i(P, { className: s, lockScroll: !0, children: /* @__PURE__ */ i(U, { context: o, children: /* @__PURE__ */ i(
    "div",
    {
      ref: l,
      "aria-labelledby": t.labelId,
      "aria-describedby": t.descriptionId,
      ...t.getFloatingProps(a),
      children: a.children
    }
  ) }) }) });
}), Z = c.forwardRef(function({ children: e, ...n }, o) {
  const { setLabelId: t } = v(), l = w();
  return c.useLayoutEffect(() => (t(l), () => t(void 0)), [l, t]), /* @__PURE__ */ i("h1", { ...n, ref: o, id: l, children: e });
}), ee = c.forwardRef(function({ children: e, ...n }, o) {
  const { setDescriptionId: t } = v(), l = w();
  return c.useLayoutEffect(() => (t(l), () => t(void 0)), [l, t]), /* @__PURE__ */ i("div", { ...n, ref: o, id: l, children: e });
}), ne = c.forwardRef(function(e, n) {
  const { setOpen: o } = v(), { trigger: t, className: l, ...r } = e, a = c.useCallback(() => o(!1), [o]);
  return /* @__PURE__ */ i("div", { className: l, children: c.cloneElement(t, {
    ref: n,
    onClick: a,
    ...r
  }) });
}), z = (e) => {
  let n = "";
  if (typeof e == "number" || typeof e == "string")
    n = "m-" + e;
  else {
    const o = [];
    (e == null ? void 0 : e.t) !== void 0 && o.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && o.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && o.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && o.push(`ml-${e.l}`), n = o.join(" ");
  }
  return n;
}, oe = ({
  children: e,
  fill: n,
  viewBox: o,
  className: t,
  defaultViewBox: l,
  defaultClassName: r,
  spacing: a,
  title: s,
  semantic: p = !1,
  ...u
}) => {
  const d = z(a), m = y(
    d,
    t || r
  );
  return /* @__PURE__ */ D(M, { children: [
    /* @__PURE__ */ i(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: m,
        viewBox: o || l,
        fill: n || "currentColor",
        role: "img",
        "aria-hidden": !p,
        focusable: !1,
        ...u,
        children: e
      }
    ),
    s && p && /* @__PURE__ */ i("span", { className: "sr-only", children: s })
  ] });
};
/*!
  @versini/ui-private v1.4.17
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.4.17",
    buildTime: "10/06/2024 10:48 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
export {
  W as LiveRegion,
  X as Modal,
  ne as ModalClose,
  Y as ModalContent,
  ee as ModalDescription,
  Z as ModalHeading,
  oe as SvgIcon
};
